/**  Kylin security execute control
 *
 *  This file contains security  apis for
 *  Kylin security exectl function
 *
 *  Authors: jiayongfeng<jiayongfeng@kylinos.cn>
 *
 *  Copyright (C) 2017,Tianjin KYLIN Information Technology Co., Ltd.
 */

#ifndef SM_FPRO_H
#define SM_FPRO_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * 将一个程序添加至文件保护
 * 返回值：
 *      0： 成功
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数路径不存在
 *      -4：添加程序至文件保护失败
 */
extern int fpro_policy_add(char *path);

/**
 * 将一个程序解除文件保护
 * 返回值：
 *      0： 成功
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数路径不存在
 *      -4：解除程序文件保护失败
 */
extern int fpro_policy_remove(char *path);

/**
 * 将目录内所有文件添加至文件保护
 * 返回值：
 *      >=0： 成功添加文件数量
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数路径不存在
 *      -4：添加目录内所有程序至文件保护失败
 */
extern int fpro_policy_add_by_dir(char *dpath);

/**
 * 将目录内所有文件解除文件保护
 * 返回值：
 *      >=0： 成功删除文件数量
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数路径不存在
 *      -4：移除目录内所有程序至文件保护失败
 */
extern int fpro_policy_remove_by_dir(char *dpath);


/**
 * 读取所有节点信息
 * 返回值：
 *      NULL：失败或记录不存在
 *      其他：成功，配置信息数组
 */
extern char **fpro_read_all_data(int *count);

#ifdef __cplusplus
}
#endif

#endif
