/**  Kylin security execute control
 *
 *  This file contains security  apis for
 *  Kylin security exectl function
 *
 *  Authors: jiayongfeng<jiayongfeng@kylinos.cn>
 *
 *  Copyright (C) 2017,Tianjin KYLIN Information Technology Co., Ltd.
 */

#ifndef SM_PBLK_H__
#define SM_PBLK_H__

#ifdef __cplusplus
extern "C" {
#endif

/**
 * 将一个程序添加至进程保护
 * 返回值：
 *      0： 成功
 *      1：包含该path的节点已经存在
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数绝对路径异常
 *      -4：参数绝对路径不存在
 *      -5：获取指定路径path在xml文件中的节点数据失败
 *      -6：内核通讯失败
 */
extern int pblk_policy_add(char *path);

/**
 * 将一个程序解除进程保护
 * 返回值：
 *      0： 成功
 *      -1：程序未授权
 *      -2：参数传入异常
 *      -3：参数绝对路径异常
 *      -4：参数绝对路径不存在
 *      -5：获取指定路径path在xml文件中的节点数据失败
 *      -6：内核通讯失败
 *      -7：移除程序进程保护失败
 */
extern int pblk_policy_remove(char *path);

/**
 * 读取所有节点信息
 * 返回值：
 *      NULL：失败或记录不存在
 *      其他：成功，配置信息数组
 */
extern char **pblk_read_all_data(int *count);

#ifdef __cplusplus
}
#endif

#endif
